// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from autoware_vehicle_msgs:srv/ControlModeCommand.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "autoware_vehicle_msgs/srv/control_mode_command.hpp"


#ifndef AUTOWARE_VEHICLE_MSGS__SRV__DETAIL__CONTROL_MODE_COMMAND__TRAITS_HPP_
#define AUTOWARE_VEHICLE_MSGS__SRV__DETAIL__CONTROL_MODE_COMMAND__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "autoware_vehicle_msgs/srv/detail/control_mode_command__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace autoware_vehicle_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const ControlModeCommand_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
    out << ", ";
  }

  // member: mode
  {
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ControlModeCommand_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }

  // member: mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ControlModeCommand_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace autoware_vehicle_msgs

namespace rosidl_generator_traits
{

[[deprecated("use autoware_vehicle_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const autoware_vehicle_msgs::srv::ControlModeCommand_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  autoware_vehicle_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use autoware_vehicle_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const autoware_vehicle_msgs::srv::ControlModeCommand_Request & msg)
{
  return autoware_vehicle_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<autoware_vehicle_msgs::srv::ControlModeCommand_Request>()
{
  return "autoware_vehicle_msgs::srv::ControlModeCommand_Request";
}

template<>
inline const char * name<autoware_vehicle_msgs::srv::ControlModeCommand_Request>()
{
  return "autoware_vehicle_msgs/srv/ControlModeCommand_Request";
}

template<>
struct has_fixed_size<autoware_vehicle_msgs::srv::ControlModeCommand_Request>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<autoware_vehicle_msgs::srv::ControlModeCommand_Request>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<autoware_vehicle_msgs::srv::ControlModeCommand_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace autoware_vehicle_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const ControlModeCommand_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ControlModeCommand_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ControlModeCommand_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace autoware_vehicle_msgs

namespace rosidl_generator_traits
{

[[deprecated("use autoware_vehicle_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const autoware_vehicle_msgs::srv::ControlModeCommand_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  autoware_vehicle_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use autoware_vehicle_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const autoware_vehicle_msgs::srv::ControlModeCommand_Response & msg)
{
  return autoware_vehicle_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<autoware_vehicle_msgs::srv::ControlModeCommand_Response>()
{
  return "autoware_vehicle_msgs::srv::ControlModeCommand_Response";
}

template<>
inline const char * name<autoware_vehicle_msgs::srv::ControlModeCommand_Response>()
{
  return "autoware_vehicle_msgs/srv/ControlModeCommand_Response";
}

template<>
struct has_fixed_size<autoware_vehicle_msgs::srv::ControlModeCommand_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<autoware_vehicle_msgs::srv::ControlModeCommand_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<autoware_vehicle_msgs::srv::ControlModeCommand_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace autoware_vehicle_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const ControlModeCommand_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ControlModeCommand_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ControlModeCommand_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace autoware_vehicle_msgs

namespace rosidl_generator_traits
{

[[deprecated("use autoware_vehicle_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const autoware_vehicle_msgs::srv::ControlModeCommand_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  autoware_vehicle_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use autoware_vehicle_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const autoware_vehicle_msgs::srv::ControlModeCommand_Event & msg)
{
  return autoware_vehicle_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<autoware_vehicle_msgs::srv::ControlModeCommand_Event>()
{
  return "autoware_vehicle_msgs::srv::ControlModeCommand_Event";
}

template<>
inline const char * name<autoware_vehicle_msgs::srv::ControlModeCommand_Event>()
{
  return "autoware_vehicle_msgs/srv/ControlModeCommand_Event";
}

template<>
struct has_fixed_size<autoware_vehicle_msgs::srv::ControlModeCommand_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<autoware_vehicle_msgs::srv::ControlModeCommand_Event>
  : std::integral_constant<bool, has_bounded_size<autoware_vehicle_msgs::srv::ControlModeCommand_Request>::value && has_bounded_size<autoware_vehicle_msgs::srv::ControlModeCommand_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<autoware_vehicle_msgs::srv::ControlModeCommand_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<autoware_vehicle_msgs::srv::ControlModeCommand>()
{
  return "autoware_vehicle_msgs::srv::ControlModeCommand";
}

template<>
inline const char * name<autoware_vehicle_msgs::srv::ControlModeCommand>()
{
  return "autoware_vehicle_msgs/srv/ControlModeCommand";
}

template<>
struct has_fixed_size<autoware_vehicle_msgs::srv::ControlModeCommand>
  : std::integral_constant<
    bool,
    has_fixed_size<autoware_vehicle_msgs::srv::ControlModeCommand_Request>::value &&
    has_fixed_size<autoware_vehicle_msgs::srv::ControlModeCommand_Response>::value
  >
{
};

template<>
struct has_bounded_size<autoware_vehicle_msgs::srv::ControlModeCommand>
  : std::integral_constant<
    bool,
    has_bounded_size<autoware_vehicle_msgs::srv::ControlModeCommand_Request>::value &&
    has_bounded_size<autoware_vehicle_msgs::srv::ControlModeCommand_Response>::value
  >
{
};

template<>
struct is_service<autoware_vehicle_msgs::srv::ControlModeCommand>
  : std::true_type
{
};

template<>
struct is_service_request<autoware_vehicle_msgs::srv::ControlModeCommand_Request>
  : std::true_type
{
};

template<>
struct is_service_response<autoware_vehicle_msgs::srv::ControlModeCommand_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // AUTOWARE_VEHICLE_MSGS__SRV__DETAIL__CONTROL_MODE_COMMAND__TRAITS_HPP_
